# coding: utf-8
import mailup.mailup_exceptions as mailup_exceptions


# LIST UTILS
def filter_list_data_dict(list_data_dict, mailup_list_fields):
    # Only keys in JMB_MAILUP_LIST_FIELDS are taken in recipient_data_dict
    filtered_dict = dict()
    for key, value in list_data_dict.iteritems():
        if key in mailup_list_fields.keys():
            filtered_dict[key] = value
    return filtered_dict


def check_list_data_dict(list_data_dict):

    # check list_data_dict
    missing_parameters = dict()
    if 'Name' not in list_data_dict:
        missing_parameters['Name'] = None

    if missing_parameters:
        raise mailup_exceptions.InvalidListConfigurationException(missing_parameters)


# GROUP UTILS
def filter_group_data_dict(group_data_dict, mailup_group_fields):
    # Only keys in JMB_MAILUP_GROUP_FIELDS are taken in recipient_data_dict
    filtered_dict = dict()
    for key, value in group_data_dict.iteritems():
        if key in mailup_group_fields.keys():
            filtered_dict[key] = value
    return filtered_dict


def check_group_data_dict(group_data_dict):
    # check list_data_dict
    missing_parameters = dict()
    if 'Name' not in group_data_dict:
        missing_parameters['Name'] = None
    if 'idList' not in group_data_dict:
        missing_parameters['idList'] = None
    if 'Notes' not in group_data_dict:
        missing_parameters['Notes'] = None
    if missing_parameters:
        raise mailup_exceptions.InvalidGroupConfigurationException(missing_parameters)


# RECIPIENT UTILS
def filter_recipient_data_dict(recipient_data_dict, mailup_recipient_fields):
    # Only keys in JMB_MAILUP_RECIPIENT_FIELDS are taken in recipient_data_dict
    filtered_dict = dict()
    for key, value in recipient_data_dict.iteritems():
        if key in mailup_recipient_fields.keys():
            filtered_dict[key] = value
    return filtered_dict


def check_recipient_data_dict(recipient_data_dict):
    # check list_data_dict
    missing_parameters = dict()
    if 'Email' not in recipient_data_dict:
        missing_parameters['Email'] = None
    if 'Name' not in recipient_data_dict:
        missing_parameters['Name'] = None
    if 'idList' not in recipient_data_dict:
        missing_parameters['idList'] = None

    if missing_parameters:
        raise mailup_exceptions.InvalidRecipientConfigurationException(missing_parameters)


# MESSAGE UTILS
def filter_message_data_dict(message_data_dict, mailup_message_fields):
    # Only keys in JMB_MAILUP_RECIPIENT_FIELDS are taken in message_data_dict
    filtered_dict = dict()
    for key, value in message_data_dict.iteritems():
        if key in mailup_message_fields.keys():
            filtered_dict[key] = value
    return filtered_dict


def check_message_data_dict(message_data_dict):
    # check list_data_dict
    missing_parameters = dict()
    if 'Subject' not in message_data_dict:
        missing_parameters['Subject'] = None
    if 'idList' not in message_data_dict:
        missing_parameters['idList'] = None

    if missing_parameters:
        raise mailup_exceptions.InvalidRecipientConfigurationException(missing_parameters)


# TAG UTILS
def filter_tag_data_dict(tag_data_dict, mailup_tag_fields):
    # Only keys in JMB_MAILUP_RECIPIENT_FIELDS are taken in tag_data_dict
    filtered_dict = dict()
    for key, value in tag_data_dict.iteritems():
        if key in mailup_tag_fields.keys():
            filtered_dict[key] = value
    return filtered_dict


def check_tag_data_dict(tag_data_dict):
    # check list_data_dict
    missing_parameters = dict()
    if 'Name' not in tag_data_dict:
        missing_parameters['Name'] = None
    if 'idList' not in tag_data_dict:
        missing_parameters['idList'] = None

    if missing_parameters:
        raise mailup_exceptions.InvalidTagConfigurationException(missing_parameters)


# ATTACHMENT UTILS
def filter_attachment_data_dict(attachment_data_dict, mailup_attachment_fields):
    # Only keys in JMB_MAILUP_RECIPIENT_FIELDS are taken in attachment_data_dict
    filtered_dict = dict()
    for key, value in attachment_data_dict.iteritems():
        if key in mailup_attachment_fields.keys():
            filtered_dict[key] = value
    return filtered_dict


def check_attachment_data_dict(attachment_data_dict):
    # check list_data_dict
    wrong_parameters = dict()
    if 'idMessage' not in attachment_data_dict:
        wrong_parameters['idMessage'] = None
    if 'Slot' not in attachment_data_dict:
        wrong_parameters['Slot'] = None
    else:
        slot = attachment_data_dict['Slot']
        if not 1 <= slot <= 5:
            wrong_parameters['Slot'] = slot

    if wrong_parameters:
        raise mailup_exceptions.InvalidRecipientConfigurationException(wrong_parameters)
